<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
      [tourAnchor]="tourEnum.preservationSpaceOrgUnitTab"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [leftTemplate]="leftTemplate"
                                [rightTemplate]="rightTemplate"
                                class="shared-detail-presentation"
  ></solidify-detail-presentation>

  <ng-template #leftTemplate>

    <solidify-image-upload-wrapper-container [tourAnchor]="tourEnum.preservationSpaceOrgUnitThumbnail"
                                             [resourceFileNameSpace]="organizationalUnitActionNameSpace"
                                             [resourceFileState]="$any(organizationalUnitState)"
                                             [uploadInstantly]="false"
                                             [isEditable]="editAvailable && isManager"
                                             (logoChange)="logoChange($event)"
    ></solidify-image-upload-wrapper-container>

  </ng-template>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    [class]="!isManager ? classInputIgnored : ''"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate}}</mat-label>
      <input (blur)="checkAvailable(formDefinition.name, fd)"
             [autocomplete]="'off'"
             [solidifyDataTest]="dataTestEnum.preservationSpaceOrgUnitName"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             autofocus
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <ng-template [ngIf]="isManager">
      <solidify-multi-select (navigate)="navigateToSubmissionPolicy($event)"
                             *ngIf="getFormControl(formDefinition.submissionPolicies) as fd"
                             [solidifyDataTest]="dataTestEnum.adminOrgUnitSubmissionPolicy"
                             [formControlDefault]="getFormControl(formDefinition.defaultSubmissionPolicy)"
                             [formControl]="fd"
                             [isWithLink]="canAccessToAdmin"
                             [labelKey]="'name'"
                             [list]="listSubmissionPolicies"
                             [matTooltipPosition]="'left'"
                             [matTooltipShowDelay]="TIME_BEFORE_DISPLAY_TOOLTIP"
                             [matTooltip]="'orgUnit.tooltips.submissionPolicy' | translate"
                             [placeholder]="labelTranslateEnum.clickHereToAddAPolicy | translate"
                             [required]="formValidationHelper.hasRequiredField(fd)"
                             [title]="labelTranslateEnum.submissionPolicies | translate"
                             [tooltipNavigateToTranslate]="labelTranslateEnum.seeSubmissionPolicyDetail | translate"
                             [valueKey]="'resId'"
                             aria-label="submission policy input"
      >
      </solidify-multi-select>

      <solidify-multi-select (navigate)="navigateToPreservationPolicy($event)"
                             *ngIf="getFormControl(formDefinition.preservationPolicies) as fd"
                             [solidifyDataTest]="dataTestEnum.adminOrgUnitPreservationPolicy"
                             [formControlDefault]="getFormControl(formDefinition.defaultPreservationPolicy)"
                             [formControl]="fd"
                             [isWithLink]="canAccessToAdmin"
                             [labelKey]="'name'"
                             [list]="listPreservationPolicies"
                             [matTooltipPosition]="'left'"
                             [matTooltipShowDelay]="TIME_BEFORE_DISPLAY_TOOLTIP"
                             [matTooltip]="'orgUnit.tooltips.preservationPolicy' | translate"
                             [placeholder]="labelTranslateEnum.clickHereToAddAPolicy | translate"
                             [required]="formValidationHelper.hasRequiredField(fd)"
                             [title]="labelTranslateEnum.preservationPolicies | translate"
                             [tooltipNavigateToTranslate]="labelTranslateEnum.seePreservationPolicyDetail | translate"
                             [valueKey]="'resId'"
                             aria-label="preservation policy input"
      >
      </solidify-multi-select>

      <dlcm-shared-organizational-unit-dissemination-policy-parameters #organizationalUnitDisseminationPolicyParametersPresentational
                                                                       [selectedDisseminationPolicies]="selectedDisseminationPolicies"
                                                                       [formControl]="getFormControl(formDefinition.disseminationPolicies)"
                                                                       (navigate)="navigate($event)"
      ></dlcm-shared-organizational-unit-dissemination-policy-parameters>
    </ng-template>

    <mat-form-field *ngIf="getFormControl(formDefinition.description) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    [class]="!isManager ? classInputIgnored : ''"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.description | translate}}</mat-label>
      <textarea [formControl]="fd"
                [required]="formValidationHelper.hasRequiredField(fd)"
                [solidifyValidation]="errors"
                cdkAutosizeMaxRows="10"
                cdkAutosizeMinRows="5"
                cdkTextareaAutosize
                matInput
      >
    </textarea>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <solidify-url-input-navigator *ngIf="getFormControl(formDefinition.url) as fd"
                                  [disabled]="!isManager"
                                  [formControl]="fd"
    >
    </solidify-url-input-navigator>

    <solidify-searchable-multi-select *ngIf="getFormControl(formDefinition.institutions) as fd"
                                      [formControl]="fd"
                                      [isWithLink]="canAccessToAdmin"
                                      [labelKey]="'name'"
                                      [labelCallback]="institutionLabelCallback"
                                      [placeholder]="labelTranslateEnum.clickHereToAddAnInstitution | translate"
                                      [required]="formValidationHelper.hasRequiredField(fd)"
                                      [resourceNameSpace]="sharedInstitutionActionNameSpace"
                                      [sort]="sharedInstitutionSort"
                                      [state]="sharedInstitutionState"
                                      [title]="labelTranslateEnum.institutions | translate"
                                      [valueKey]="'resId'"
                                      [isDisabled]="!isManager"
                                      [overlayComponent]="$any(institutionOverlayComponent)"
                                      (navigate)="navigateToInstitution($event)"
                                      aria-label="institution"
                                      solidifyValidation
    >
    </solidify-searchable-multi-select>

    <solidify-searchable-single-select #licenseSingleSearchableSelect
                                       *ngIf="getFormControl(formDefinition.defaultLicense) as fd"
                                       (navigate)="navigateToLicense($event)"
                                       [defaultValueTooltip]="'defaultValue' | translate"
                                       [defaultValue]="defaultPlatformLicenseId"
                                       [formControl]="fd"
                                       [isWithLink]="canAccessToAdmin"
                                       [labelCallback]="licenseCallback"
                                       [labelKey]="'title'"
                                       [placeholder]="labelTranslateEnum.license | translate"
                                       [required]="formValidationHelper.hasRequiredField(fd)"
                                       [resourceNameSpace]="sharedLicenseActionNameSpace"
                                       [sort]="sharedLicenseSort"
                                       [state]="sharedLicenseState"
                                       [tooltipNavigateToTranslate]="labelTranslateEnum.seeLicenseDetail | translate"
                                       [urlKey]="'url'"
                                       [valueKey]="'resId'"
                                       [overlayComponent]="$any(licenseOverlayComponent)"
                                       aria-label="license"
                                       solidifyValidation
    >
    </solidify-searchable-single-select>


  </ng-template>

  <ng-template #rightTemplate>

    <ng-template [ngIf]="isManager">

      <mat-form-field (click)="openingDateDatepicker.open()"
                      *ngIf="getFormControl(formDefinition.openingDate) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.opening | translate}}</mat-label>
        <input [autocomplete]="'off'"
               [formControl]="fd"
               [matDatepicker]="openingDateDatepicker"
               [required]="formValidationHelper.hasRequiredField(fd)"
               matInput
        >
        <mat-datepicker-toggle [for]="openingDateDatepicker"
                               matSuffix
        ></mat-datepicker-toggle>
        <mat-datepicker #openingDateDatepicker
                        [touchUi]="breakpointService.isSmallerThanMd()"
        ></mat-datepicker>
      </mat-form-field>

      <mat-form-field (click)="closingDateDatepicker.open()"
                      *ngIf="getFormControl(formDefinition.closingDate) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.closing | translate}}</mat-label>
        <input [autocomplete]="'off'"
               [formControl]="fd"
               [matDatepicker]="closingDateDatepicker"
               [required]="formValidationHelper.hasRequiredField(fd)"
               matInput
        >
        <mat-datepicker-toggle [for]="closingDateDatepicker"
                               matSuffix
        ></mat-datepicker-toggle>
        <mat-datepicker #closingDateDatepicker
                        [touchUi]="breakpointService.isSmallerThanMd()"
        ></mat-datepicker>
      </mat-form-field>

      <mat-form-field *ngIf="getFormControl(formDefinition.filterSubjectAreas) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      [matTooltipPosition]="'left'"
                      [matTooltipShowDelay]="TIME_BEFORE_DISPLAY_TOOLTIP"
                      [matTooltip]="'admin.organizationalUnit.form.subjectAreaSource.tooltip' | translate"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.filteringSubjectAreaBySource | translate}}</mat-label>
        <mat-select (valueChange)="filterSubjectArea($event)"
                    [formControl]="fd"
        >
          <mat-option [value]="''"
                      solidifyTooltipOnEllipsis
          >
            {{labelTranslateEnum.noFiltering | translate}}
          </mat-option>
          <mat-option *ngFor="let source of subjectDomainSources"
                      [value]="source"
                      solidifyTooltipOnEllipsis
          >
            {{source}}
          </mat-option>
        </mat-select>
      </mat-form-field>

      <solidify-searchable-multi-select *ngIf="getFormControl(formDefinition.subjectAreas) as fd"
                                        [extraInfoLabelKey]="'code'"
                                        [extraSearchQueryParam]="extraSearchParameterSource"
                                        [formControl]="fd"
                                        [isWithLink]="canAccessToAdmin"
                                        [labelCallback]="subjectAreaLabelCallback"
                                        [labelKey]="'name'"
                                        [placeholder]="'admin.organizationalUnit.form.subjectAreas.placeholder' | translate"
                                        [required]="formValidationHelper.hasRequiredField(fd)"
                                        [resourceNameSpace]="sharedSubjectAreaActionNameSpace"
                                        [searchKey]="'nameOrCode'"
                                        [sort]="sharedSubjectAreaSort"
                                        [state]="sharedSubjectAreaState"
                                        [title]="labelTranslateEnum.subjectAreas | translate"
                                        [valueKey]="'resId'"
                                        aria-label="subject area"
                                        solidifyValidation
      >
      </solidify-searchable-multi-select>

      <solidify-keyword-input *ngIf="getFormControl(formDefinition.keywords) as fd"
                              [formControl]="fd"
                              [readonly]="readonly"
                              [spaceDelimiter]="false"
      >
      </solidify-keyword-input>

    </ng-template>

    <ng-container *ngTemplateOutlet="link"></ng-container>

  </ng-template>

  <solidify-panel-expandable *ngIf="isManager || (isMemberOrgUnit && (selectedPersonRole | isNonEmptyArray))"
                             [isOpen]="true"
                             [titleToTranslate]="labelTranslateEnum.organizationalUnitMembers | translate"
                             [icon]="iconNameEnum.organizationalUnit"
                             [tourAnchor]="tourEnum.preservationSpaceOrgUnitPersonRole"
                             class="section"
  >
    <dlcm-shared-table-person-role-container [formControl]="getFormControl(formDefinition.personRole)"
                                             [listRole]="listRole"
                                             [readonly]="readonly"
                                             [selectedResourceRole]="selectedPersonRole"
                                             [isWithLinkToAdmin]="securityService.isRootOrAdmin()"
                                             [highlightedResourceId]="personIdAutomaticallyAdded"
                                             (navigate)="navigate($event)"
                                             [preventEdition]="!isManager"
    ></dlcm-shared-table-person-role-container>
  </solidify-panel-expandable>

  <solidify-panel-expandable *ngIf="readonly && (inheritedSelectedPersonRole | isNonEmptyArray)"
                             [isOpen]="true"
                             [titleToTranslate]="(getFormControl(formDefinition.institutions)?.value?.length > 1 ? labelTranslateEnum.institutionsMembers :
                               labelTranslateEnum.institutionMembers) | translate"
                             [icon]="iconNameEnum.institutions"
                             class="section"
  >
    <dlcm-shared-table-person-role-container *ngIf="getFormControl(formDefinition.inheritedPersonRole) as fd"
                                             [formControl]="fd"
                                             [listRole]="listRole"
                                             [readonly]="true"
                                             [preventEdition]="true"
                                             [selectedResourceRole]="inheritedSelectedPersonRole"
                                             [isWithLinkToAdmin]="securityService.isRootOrAdmin()"
                                             [highlightedResourceId]="personIdAutomaticallyAdded"
                                             (navigate)="navigate($event)"
                                             [class]="classBypassEdit"
    ></dlcm-shared-table-person-role-container>
  </solidify-panel-expandable>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>

</form>

<!--TEMPLATE BELOW-->
<ng-template #link>
  <button (click)="goToDeposit()"
          (onEnter)="goToDeposit()"
          *ngIf="readonly && securityService.isRootOrAdmin() || securityService.isMemberOfOrgUnitAboveVisitor(model.resId)"
          [solidifyAlternativeButtonIcon]="true"
          [solidifyDataTest]="dataTestEnum.preservationSpaceOrgUnitButtonSeeDeposit"
          solidifyAlternativeButton
          solidifyShortCuts
  >
    <solidify-icon [iconName]="iconNameEnum.deposit"
                   class="icon"
    ></solidify-icon>
    <span class="text">{{labelTranslateEnum.seeDeposits | translate}}</span>
  </button>

  <button (click)="goToArchive()"
          (onEnter)="goToArchive()"
          *ngIf="readonly"
          [solidifyAlternativeButtonIcon]="true"
          solidifyAlternativeButton
          solidifyShortCuts
  >
    <solidify-icon [iconName]="iconNameEnum.archive"
                   class="icon size-18"
    ></solidify-icon>
    <span class="text">{{labelTranslateEnum.seeArchives | translate}}</span>
  </button>

  <button (click)="goToReceivedRequestNotification()"
          (onEnter)="goToReceivedRequestNotification()"
          *ngIf="readonly && securityService.isRootOrAdmin() || securityService.isManagerOfOrgUnit(model.resId)"
          [solidifyAlternativeButtonIcon]="true"
          [solidifyDataTest]="dataTestEnum.preservationSpaceOrgUnitButtonSeeReceivedRequest"
          solidifyAlternativeButton
          solidifyShortCuts
  >
    <solidify-icon [iconName]="iconNameEnum.notifications"
                   class="icon size-18"
    ></solidify-icon>
    <span class="text">{{labelTranslateEnum.seeNotifications | translate}}</span>
  </button>

  <button (click)="goToManageArchiveAcl()"
          (onEnter)="goToManageArchiveAcl()"
          *ngIf="readonly && securityService.isRootOrAdmin() || securityService.isStewardOfOrgUnit(model.resId)"
          [solidifyAlternativeButtonIcon]="true"
          solidifyAlternativeButton
          solidifyShortCuts
  >
    <solidify-icon [iconName]="iconNameEnum.archiveAcl"
                   class="icon size-18"
    ></solidify-icon>
    <span class="text">{{labelTranslateEnum.manageArchiveAcl | translate}}</span>
  </button>

  <button (click)="goToSentRequestNotification()"
          (onEnter)="goToSentRequestNotification()"
          *ngIf="readonly"
          [solidifyAlternativeButtonIcon]="true"
          solidifyAlternativeButton
          solidifyShortCuts
  >
    <solidify-icon [iconName]="iconNameEnum.requestSent"
                   class="icon size-18"
    ></solidify-icon>
    <span class="text">{{labelTranslateEnum.seeSentRequest | translate}}</span>
  </button>

  <button (click)="requestToBeMember()"
          (onEnter)="requestToBeMember()"
          *ngIf="readonly && !isManager"
          [solidifyAlternativeButtonIcon]="true"
          [solidifyDataTest]="dataTestEnum.preservationSpaceOrgUnitButtonAskJoinOrgUnit"
          solidifyAlternativeButton
          [solidifyAlternativeButtonDisableRipple]="true"
          solidifyShortCuts
          dlcmPendingAccessRequestButton
          [dlcmPendingAccessRequestButtonType]="'orgUnit'"
          [dlcmPendingAccessRequestButtonResourceId]="model.resId"
  >
    <solidify-icon [iconName]="iconNameEnum.sendRequest"
                   class="icon size-18"
    ></solidify-icon>
    <span class="text">{{
            (securityService.isMemberOfOrgUnit(model?.resId) ? labelTranslateEnum.changeRoleInOrgUnit : labelTranslateEnum.requestMembership) |
                translate
      }}</span>
  </button>

  <button (click)="leaveOrganizationalUnit()"
          (onEnter)="leaveOrganizationalUnit()"
          *ngIf="readonly && canLeaveOrganizationalUnit"
          [solidifyAlternativeButtonIcon]="true"
          solidifyAlternativeButton
          solidifyShortCuts
  >
    <solidify-icon [iconName]="iconNameEnum.leaveOrganizationalUnit"
                   class="icon size-18"
    ></solidify-icon>
    <span class="text">{{labelTranslateEnum.leaveTheOrganizationalUnit | translate}}</span>
  </button>

</ng-template>
